/*
 * 쐬: 2007/11/30
 * 쌠: Copyright (c) 2007 kry
 * CZXFEclipse Public License - v 1.0
 * Fhttp://www.eclipse.org/legal/epl-v10.html
 */
package kry.sql.constant;

/**
 * @author kry
 *
 */
public interface IOracleConstant extends IANSISqlConstant {

	public static final String[] RESERVED_WORDS = { "ABORT", "ACCOUNT", "ADD",
			"ADMIN", "ADVISE", "ADVISOR", "AFTER", "ALIAS", "ALL", "ALTER",
			"ALWAYS", "AND", "ANY", "APPLY", "ARCHIVE", "AS", "ASC",
			"ATTRIBUTES", "AUDIT", "AUTHENTICATION", "AUTO", "AUTOMATIC",
			"AVAILABILITY", "BECOME", "BETWEEN", "BFILE", "BIGFILE",
			"BINARY_DOUBLE", "BINARY_FLOAT", "BINARY_FLOAT_NAN", "BITMAP",
			"BITMAPS", "BITMAP_TREE", "BITS", "BLOB", "BLOCKSIZE", "BODY",
			"BOTH", "BROADCAST", "BULK", "BYPASS_RECURSIVE_CHECK", "BY",
			"BYTE", "CACHE", "CACHE_CB", "CACHE_INSTANCES", "CACHE_TEMP_TABLE",
			"CANCEL", "CARDINALITY", "CASCADE", "CFILE", "CHAR_CS", "CHECK",
			"CHILD", "CHOOSE", "CHUNK", "CIV_GB", "CLASS", "CLOB", "CLUSTER",
			"COALESCE", "COARSE", "COLLECT", "COLUMN", "COLUMNS",
			"COLUMN_STATS", "COMMENT", "COMMITTED", "COMPILE", "COMPLETE",
			"COMPOSITE_LIMIT", "CONNECT_BY_ROOT", "CONSTRAINT", "CONTAINER",
			"CONTENT", "CONTEXT", "CONTINUE", "CONVERT", "CORRUPTION", "COST",
			"CPU_PER_CALL", "CREATE", "CROSS", "CURRENT", "CURRENT_DATE",
			"CURSOR_SHARING_EXACT", "CURSOR_SPECIFIC_SEGMENT", "DATA",
			"DATAFILE", "DATAFILES", "DATAOBJNO", "DATE", "DAY", "DBA",
			"DBA_RECYCLEBIN", "DBMS_STATS", "DECLARE", "DEFAULT", "DEFINED",
			"DEFINER", "DEGREE", "DELAY", "DELETE", "DEMAND", "DENSE_RANK",
			"DEQUEUE", "DEREF_NO_REWRITE", "DESC", "DETACHED", "DICTIONARY",
			"DIMENSION", "DISABLE", "DISASSOCIATE", "DISCONNECT", "DISK",
			"DISMOUNT", "DISTINCT", "DISTRIBUTED", "DML",
			"DOMAIN_INDEX_NO_SORT", "DOMAIN_INDEX_SORT", "DRIVING_SITE",
			"DROP", "DESC", "DUMP", "DYNAMIC", "DYNAMIC_SAMPLING", "EACH",
			"ELIMINATE_OUTER_JOIN", "ELSE", "EMPTY", "ENABLE", "ENCRYPTION",
			"END", "ENFORCED", "ENTERPRISE", "ERROR", "ERRORS", "ESCAPE",
			"ESTIMATE", "EVALNAME", "EVALUATION", "EXCEPT", "EXCEPTIONS",
			"EXCLUDING", "EXISTS", "EXPAND_GSET_TO_UNION", "EXPIRE",
			"EXPLOSION", "EXPORT", "EXTRACT", "FACT", "FAILED",
			"FAILED_LOGIN_ATTEMPTS", "FAST", "FBTSCAN", "FIC_CIV", "FIC_PIV",
			"FILE", "FINAL", "FINISH", "FLAGGER", "FLOAT", "FLOB", "FORCE",
			"FREELIST", "FRESH", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "G",
			"GBY_CONC_ROLLUP", "GRANT", "GROUPING", "GROUPS", "GROUP",
			"GUARANTEED", "GUARD", "HASH", "HASHKEYS", "HASH_AJ", "HAVING",
			"HEAP", "HIERARCHY", "HIGH", "HINTSET_BEGIN", "HINTSET_END",
			"HOUR", "IDENTIFIED", "IF", "IGNORE_OPTIM_EMBEDDED_HINTS", "IN",
			"INDEXTYPES", "INDEX_ASC", "INDEX_COMBINE", "INDEX_FILTER",
			"INDEX_ROWS", "INDEX_RRS", "INDEX_SS", "INDEX_SS_ASC", "INDICATOR",
			"INFINITE", "INFORMATIONAL", "INITIAL", "INITRANS",
			"INLINE_XMLTYPE_NT", "INSERT", "INSTANCE", "INTEGER", "INTERSECT",
			"INTERMEDIATE", "INTERPRETED", "INTO", "IS", "ITERATION_NUMBER",
			"JOB", "JOIN", "KEYSIZE", "KILL", "LATERAL",
			"LDAP_REG_SYNC_INTERVAL", "LEADING", "LEFT", "LENGTH", "LESS",
			"LEVEL", "LIBRARY", "LIKE4", "LIKEC", "LINK", "LOB", "LOCALTIME",
			"LOCALTIMESTAMP", "LOGFILE", "LONG", "M", "MANAGE", "MATCHED",
			"MATERIALIZED", "MAX", "MAXEXTENTS", "MAXIMIZE", "MAXLOGHISTORY",
			"MAXLOGMEMBERS", "MAXTRANS", "MAXVALUE", "MEMBER", "MERGE",
			"MERGE_CONST_ON", "MINEXTENTS", "MINIMIZE", "MINIMUM", "MINUS",
			"MIRROR", "MODEL_PBY", "MODIFY", "MOUNT", "MOVE", "MOVEMENT",
			"MULTISET", "NAME", "NAMED", "NAN", "NATIONAL", "NATURAL",
			"NESTED_TABLE_FAST_INSERT", "NESTED_TABLE_SET_REFS", "NEW",
			"NLS_CHARACTERSET", "NLS_DATE_FORMAT", "NLS_LANG",
			"NLS_LENGTH_SEMANTICS", "NLS_SPECIAL_CHARS", "NL_SJ", "NO",
			"NOFORCE", "NOGUARANTEE", "NOLOGGING", "NOMINVALUE",
			"NOMONITORING", "NONE", "NOORDER", "NOOVERRIDE", "NOPARALLEL",
			"NOPARALLEL_INDEX", "NORELY", "NOREPAIR", "NORESETLOGS",
			"NOROWDEPENDENCIES", "NOSEGMENT", "NOSTRICT", "NOSWITCH", "NOT",
			"NOTHING", "NOWAIT", "NO_BASETABLE_MULTIMV_REWRITE", "NO_BUFFER",
			"NO_CARTESIAN", "NO_ELIMINATE_JOIN", "NO_ELIMINATE_OBY",
			"NO_ELIMINATE_OUTER_JOIN", "NO_EXPAND", "NO_FILTERING",
			"NO_MULTIMV_REWRITE", "NO_PRUNE_GSETS", "NO_PUSH_SUBQ",
			"NO_PX_JOIN_FILTER", "NO_QUERY_TRANSFORMATION", "NO_SEMIJOIN",
			"NO_SQL_TUNE", "NO_STATS_GSETS", "NO_USE_HASH",
			"NO_XML_QUERY_REWRITE", "NULL", "NUMBER", "NUMERIC", "OBJNO",
			"OBJNO_REUSE", "OFF", "OFFLINE", "OID", "OIDINDEX", "OLD",
			"OLD_PUSH_PRED", "ON", "ONLINE", "ONLY", "OPAQUE",
			"OPAQUE_XCANONICAL", "OPCODE", "OPTIMIZER_FEATURES_ENABLE",
			"OPTION", "OPT_ESTIMATE", "OR", "ORA_ROWSCN", "ORDER",
			"ORDERED_PREDICATES", "ORGANIZATION", "OUTER", "OUT_OF_LINE",
			"OVERFLOW", "OWN", "P", "PARAMETERS", "PARTITION",
			"PARTITION_HASH", "PARTITION_LIST", "PASSWORD",
			"PASSWORD_GRACE_TIME", "PASSWORD_LOCK_TIME",
			"PASSWORD_VERIFY_FUNCTION", "PATH", "PIV_SSF", "PLAN", "POINT",
			"POLICY", "POST_TRANSACTION", "POWER", "PQ_NOMAP", "PREBUILT",
			"PRECEDING", "PRECISION", "PRECOMPUTE_SUBQUERY", "PREPARE",
			"PRESENT", "PRIOR", "PRIVATE", "PRIVATE_SGA", "PRIVILEGE",
			"PRIVILEGES", "PROTECTED", "PURGE", "PUSH_SUBQ", "PX_JOIN_FILTER",
			"QB_NAME", "QUERY", "QUEUE_ROWP", "QUOTA", "RAW", "RBA", "READ",
			"READS", "REAL", "REBUILD", "RECORDS_PER_BLOCK", "RECYCLE",
			"RECYCLEBIN", "REDUNDANCY", "REF", "REFRESH", "REF_CASCADE_CURSOR",
			"REJECT", "RELATIONAL", "REPLACE", "REQUIRED", "RESET", "RESIZE",
			"RESOURCE", "RETENTION", "RETURNING", "REVERSE",
			"REWRITE_OR_ERROR", "RIGHT", "ROLE", "ROLES", "ROLLING", "ROW",
			"ROWDEPENDENCIES", "ROWID", "RULE", "SALT", "SAVE_AS_INTERVALS",
			"SB4", "SCALE", "SCAN_INSTANCES", "SCHEDULER", "SCN_ASCENDING",
			"SD_SHOW", "SECOND", "SECURITY", "SEED", "SEMIJOIN", "SELECT",
			"SERVERERROR", "SESSION", "SESSIONS_PER_USER", "SESSIONTZNAME",
			"SESSION_CACHED_CURSORS", "SET", "SETS", "SETTINGS", "SEVERE",
			"SHARE", "SHARED_POOL", "SID", "SINGLE", "SKIP",
			"SKIP_EXT_OPTIMIZER", "SMALLFILE", "SOME", "SOURCE", "SPACE",
			"SQL", "SQL_TRACE", "STAR", "STORAGE", "STORE", "STREAMS", "STRIP",
			"SUBMULTISET", "SUBPARTITION_REL", "SUSPEND", "SWAP_JOIN_INPUTS",
			"SYSAUX", "SYSDBA", "SYSTEM", "SYSTIMESTAMP", "SYS_DL_CURSOR",
			"SYS_OP_BITVEC", "SYS_PARALLEL_TXN", "TABLE", "TABLESPACE",
			"TABLE_STATS", "TABNO", "TEMPFILE", "TEMP_TABLE", "THAN", "THEN",
			"THREAD", "THROUGH", "TIME", "TIMEOUT", "TIMESTAMP",
			"TIMEZONE_HOUR", "TIV_SSF", "TO", "TOPLEVEL", "TRACE", "TRACING",
			"TRAILING", "TRANSACTION", "TRANSITIONAL", "TRIGGERS", "TRUNCATE",
			"TRUSTED", "TYPE", "TYPES", "TZ_OFFSET", "UB2", "UBA", "UNBOUND",
			"UNBOUNDED", "UNDO", "UNION", "UNPACKED", "UNQUIESCE", "UPDATE",
			"UPD_JOININDEX", "USE", "USER", "USE_ANTI", "USE_NL",
			"USE_NL_WITH_INDEX", "USE_SEMI", "USE_STORED_OUTLINES", "USING",
			"VALUE", "VALUES", "VARRAY", "VECTOR_READ", "VECTOR_READ_TRACE",
			"VERSION", "VIEW", "WAIT", "WHEN", "WHERE", "WITH", "WITHIN",
			"WORK", "XID", "XMLATTRIBUTES", "XMLCOLATTVAL", "XMLFOREST",
			"X_DYN_PRUNE", "YEAR" };

	public static final String[] DATA_TYPES = { "BFILE", "BINARY_DOUBLE",
			"BINARY_FLOAT", "BLOB", "CHAR", "CLOB", "DATE", "INTERVAL DAY",
			"INTERVAL YEAR", "LONG", "LONG RAW", "NCHAR", "NCLOB", "NUMBER",
			"NVARCHAR2", "RAW", "ROWID", "TIMESTAMP", "TO MONTH", "TO SECOND",
			"UROWID", "VARCHAR2" };

	public static final String[] FUNCTIONS = { "ABS", "ACOS", "ADD_MONTHS",
			"APPENDCHILDXML", "ASCII", "ASCIISTR", "ASIN", "ATAN", "ATAN2",
			"AVG", "BFILENAME", "BIN_TO_NUM", "BITAND", "CARDINALITY", "CAST",
			"CEIL", "CHARTOROWID", "CHR", "CLUSTER_ID", "CLUSTER_PROBABILITY",
			"CLUSTER_SET", "COALESCE", "COLLECT", "COLLECT", "COMPOSE",
			"CONCAT", "CONVERT", "CORR", "CORR_*", "COS", "COSH", "COUNT",
			"COVAR_POP", "COVAR_SAMP", "CUME_DIST", "CURRENT_DATE",
			"CURRENT_TIMESTAMP", "DBTIMEZONE", "DECODE", "DECOMPOSE",
			"DELETEXML", "DENSE_RANK", "DEPTH", "DUMP", "EMPTY_BLOB",
			"EMPTY_CLOB", "EXISTSNODE", "EXP", "EXTRACT", "EXTRACTiXMLj",
			"EXTRACTVALUE", "FEATURE_ID", "FEATURE_SET", "FEATURE_VALUE",
			"FIRST", "FLOOR", "FROM_TZ", "GREATEST", "GROUP_ID", "GROUPING",
			"GROUPING_ID", "HEXTORAW", "INITCAP", "INSERTCHILDXML",
			"INSERTXMLBEFORE", "INSTR", "LAST", "LAST_DAY", "LEAST", "LENGTH",
			"LN", "LNNVL", "LOCALTIMESTAMP", "LOG", "LOWER", "LPAD", "LTRIM",
			"MAX", "MEDIAN", "MIN", "MOD", "MONTHS_BETWEEN", "NANVL",
			"NEW_TIME", "NEXT_DAY", "NLS_CHARSET_DECL_LEN", "NLS_CHARSET_ID",
			"NLS_CHARSET_NAME", "NLS_INITCAP", "NLS_LOWER", "NLS_UPPER",
			"NLSSORT", "NULLIF", "NUMTODSINTERVAL", "NUMTODSINTERVAL",
			"NUMTOYMINTERVAL", "NUMTOYMINTERVAL", "NVL", "NVL2", "ORA_HASH",
			"PATH", "PERCENT_RANK", "PERCENTILE_CONT", "PERCENTILE_DISC",
			"POWER", "POWERMULTISET", "POWERMULTISET_BY_CARDINALITY",
			"PREDICTION", "PREDICTION_COST", "PREDICTION_DETAILS",
			"PREDICTION_PROBABILITY", "PREDICTION_SET", "RANK", "RAWTOHEX",
			"RAWTONHEX", "REGEXP_INSTR", "REGEXP_REPLACE", "REGEXP_SUBSTR",
			"REGR_AVGX", "REGR_AVGY", "REGR_COUNT", "REGR_INTERCEPT",
			"REGR_R2", "REGR_SLOPE", "REGR_SXX", "REGR_SXY", "REGR_SYY",
			"REMAINDER", "REPLACE", "ROUND", "ROUND", "ROWIDTOCHAR",
			"ROWIDTONCHAR", "RPAD", "RTRIM", "SCN_TO_TIMESTAMP",
			"SESSIONTIMEZONE", "SIGN", "SIN", "SINH", "SOUNDEX", "SQRT",
			"STATS_BINOMIAL_TEST", "STATS_CROSSTAB", "STATS_F_TEST",
			"STATS_KS_TEST", "STATS_MODE", "STATS_MW_TEST",
			"STATS_ONE_WAY_ANOVA", "STATS_T_TEST_*", "STATS_WSR_TEST",
			"STDDEV", "STDDEV_POP", "STDDEV_SAMP", "SUBSTR", "SUM",
			"SYS_CONNECT_BY_PATH", "SYS_CONTEXT", "SYS_DBURIGEN",
			"SYS_EXTRACT_UTC", "SYS_GUID", "SYS_TYPEID", "SYS_XMLAGG",
			"SYS_XMLGEN", "SYSDATE", "SYSTIMESTAMP", "TAN", "TANH",
			"TIMESTAMP_TO_SCN", "TO_BINARY_DOUBLE", "TO_BINARY_FLOAT",
			"TO_CHAR", "TO_CHAR", "TO_CLOB", "TO_DATE", "TO_DSINTERVAL",
			"TO_DSINTERVAL", "TO_DSINTERVAL", "TO_LOB", "TO_MULTI_BYTE",
			"TO_NCHAR", "TO_NCLOB", "TO_NUMBER", "TO_SINGLE_BYTE",
			"TO_TIMESTAMP", "TO_TIMESTAMP", "TO_TIMESTAMP_TZ",
			"TO_TIMESTAMP_TZ", "TO_YMINTERVAL", "TO_YMINTERVAL", "TRANSLATE",
			"TRANSLATE", "TREAT", "TRIM", "TRUNC", "TRUNC", "TZ_OFFSET", "UID",
			"UNISTR", "UPDATEXML", "UPPER", "USER", "USERENV", "VAR_POP",
			"VAR_SAMP", "VARIANCE", "VSIZE", "WIDTH_BUCKET", "XMLAGG",
			"XMLCDATA", "XMLCOLATTVAL", "XMLCOMMENT", "XMLCONCAT", "XMLFOREST",
			"XMLPARSE", "XMLPI", "XMLQUERY", "XMLROOT", "XMLSEQUENCE",
			"XMLSERIALIZE", "XMLTABLE", "XMLTRANSFORM" };

	// SQL
	public static final String[] SQL_STATEMENTS = { "ALTER", "COMMENT",
			"COMMIT", "CREATE", "DELETE", "DROP", "GRANT", "INSERT", "REVOKE",
			"ROLLBACK", "SELECT", "UPDATE" };

	// }`L[[h
	public static final String[] MULTI_KEYWORDS = { "ADD COLUMN",
			"ALTER COLUMN", "ALTER TABLE", "COMMENT ON COLUMN",
			"COMMENT ON TABLE", "CREATE FORCE VIEW", "CREATE OR REPLACE VIEW",
			"CREATE TABLE", "CREATE VIEW", "CROSS JOIN", "DROP COLUMN",
			"DROP CONSTRAINT", "DROP DEFAULT", "DROP TABLE", "DROP VIEW",
			"GROUP BY", "INTERVAL DAY", "INTERVAL YEAR", "LEFT JOIN",
			"LEFT OUTER JOIN", "LONG RAW", "NATURAL JOIN",
			"NATURAL LEFT OUTER JOIN", "NATURAL RIGHT OUTER JOIN", "ORDER BY",
			"RIGHT JOIN", "RIGHT OUTER JOIN", "SELECT ALL", "SELECT DISTINCT",
			"SET DEFAULT", "TO MONTH", "TO SECOND", "TRUNCATE TABLE",
			"UNION ALL", "UNION JOIN", "WHEN MATCHED THEN",
			"WHEN NOT MATCHED THEN", "WITH CHECK OPTION",
			"WITH LOCAL TIME ZONE", "WITH READ ONLY", "WITH TIME ZONE" };

	// L
	public static final String[] SYMBOLS = { "(", ")", "||", ".", ",", "(+)",
			"(*)" };

	// Zq
	public static final String[] OPERATORS = { "!=", "*", "+", "-", "/", "<",
			"<=", "<>", "=", ">", ">=", "^=" };

	// Rg
	public static final String[] SINGLE_LINE_COMMENTS = { "--" };
}
